const WebSocket = require('ws');

const websocket_connections = {};
let master = null;

const wss = new WebSocket.Server({ port: 16688 });

wss.on('connection', function connection(ws, req) {
    const client_ip = req.connection.remoteAddress;
    console.log("conn")
    websocket_connections[client_ip] = ws;

    ws.on('message', async function incoming(message) {
        if (message.toString()[0] === '#') {
            master = client_ip;
            const requete = [];

            console.log(`Il y a ${Object.keys(websocket_connections).length}`);

            for (const [ip, websocket] of Object.entries(websocket_connections)) {
                if (ip !== master) {
                    requete.push(determineResponse(websocket, "search 74d181ce69fa53e60fb588719cc404e1 a 9999"));
                }
            }

            await Promise.all(requete);
            await ws.send("Vous êtes le maître.");
        }
    });
});

async function determineResponse(ws, requete) {
    console.log("ici");
    ws.send(requete);
    const reponse = await new Promise(resolve => {
        ws.once('message', message => resolve(message));
    });
    console.log(reponse.toString()[0]);
}

console.log('Server running on port 16688');
